#include"cuberenderer.hpp"
#include"planerenderer.hpp"


using tmpl1 = PlaneRenderer<PixelMap16,pixel16_t>;
using tmpl2 = PlaneRenderer<Drawer,pixel32_t>;


void  CubeRenderer::  fill_top_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){  tmpl1::fill_top(dst,pixel,Cube::side_length,x,y);}
void  CubeRenderer::fill_front_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){tmpl1::fill_front(dst,pixel,Cube::side_length,x,y);}
void  CubeRenderer::fill_right_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){tmpl1::fill_right(dst,pixel,Cube::side_length,x,y);}

void  CubeRenderer::  fill_top_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){  tmpl2::fill_top(dst,to_pixel32(pixel),Cube::side_length,x,y);}
void  CubeRenderer::fill_front_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){tmpl2::fill_front(dst,to_pixel32(pixel),Cube::side_length,x,y);}
void  CubeRenderer::fill_right_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){tmpl2::fill_right(dst,to_pixel32(pixel),Cube::side_length,x,y);}





