#include"video.hpp"




namespace{


uint32_t
colors_[0x1000];


SDL_PixelFormat
format;


}


void
reset_color_table(uint32_t  pixel_format)
{
  auto  fmt = SDL_AllocFormat(pixel_format);

    rep(b4,16){
    rep(g4,16){
    rep(r4,16){
      uint8_t  r8 = (r4? ((r4<<4)|15):0);
      uint8_t  g8 = (g4? ((g4<<4)|15):0);
      uint8_t  b8 = (b4? ((b4<<4)|15):0);

      colors_[to_pixel16(r4,g4,b4)&0xFFF] = SDL_MapRGB(fmt,r8,g8,b8);
    }}}


  format = *fmt;

  SDL_FreeFormat(fmt);
}


uint32_t
to_pixel32(pixel16_t  pixel)
{
  return colors_[pixel&0xFFF];
}


uint32_t
to_pixel32(int  r, int  g, int  b)
{
  return to_pixel32(to_pixel16(r,g,b));
}


uint32_t
to_pixel(uint8_t  r, uint8_t  g, uint8_t  b)
{
  return SDL_MapRGB(&format,r,g,b);
}




